#!/usr/bin/python
import datetime
from time import *
import pandas as pd
   
def load_rates(filename):
    print "loading rates"
    start_time = datetime.datetime.now()
    main_rates = pd.read_csv(filename, index_col=0, parse_dates=True, dayfirst=True)
    main_rates.columns = ['open', 'high', 'low', 'close', 'vol']
    main_rates = main_rates.drop('vol', 1)
    print "loading rates took {} seconds".format((datetime.datetime.now()-start_time).total_seconds())
    return main_rates

def run_simulation(main_rates):

    start_time = datetime.datetime.now()
    average_range = []
               
    for i in range(2, len(main_rates.index)):
    
        timestamp         = main_rates.index[i]
        current_open      = main_rates.ix[i, 0]
        current_high      = main_rates.ix[i, 1]
        current_low       = main_rates.ix[i, 2]
        current_close     = main_rates.ix[i, 3]
        current_hour      = main_rates.index[i].hour
        
        range_value = 0
                   
        for j in range(0, 20):
            highValue = main_rates.ix[i-j-1, 1]
            lowValue  = main_rates.ix[i-j-1, 2]
            range_value +=  abs(highValue-lowValue)/20 

        average_range.append(range_value)
        
        if i % 1000 == 0:
            print "average range {} at index {} with time {}".format(range_value, i, timestamp)
        
    print "doing entire pass took {} seconds".format((datetime.datetime.now()-start_time).total_seconds())
        
                    
def main():
    rates = load_rates("TEST_60.csv")
    run_simulation(rates)
    
    
##################################
###           MAIN           ####
##################################

if __name__ == "__main__": main()
